/**
 * ControlP5 by Andreas Schlegel 
 * http://www.sojamo.de/libraries/controlP5/
 * exemple Wolf Ka cours art & programmation
 */

import controlP5.*;  
ControlP5 controlP5;   

color c;
float val;
void setup() {
  size(320, 200);
  smooth();

  controlP5 = new ControlP5(this);

  controlP5.addBang("bang", 10, 10, 30, 30);

  controlP5.addButton("button", 20, 70, 10, 40, 40);

  controlP5.addToggle("toggle", false, 170, 10, 30, 30);

  Slider s = controlP5.addSlider("slider", 0, 255, 128, 70, 80, 80, 15);
  s.captionLabel().style().marginLeft = -36;
  s.captionLabel().style().marginTop = -15;

  controlP5.addKnob("knob", 0, 400, 59, 70, 120, 40);

  controlP5.addNumberbox("numberbox", 50, 170, 120, 40, 20);

  Radio r = controlP5.addRadio("radio", 10, 120);
  r.deactivateAll(); // use deactiveAll to not make the first radio button active.
  r.add("red", 1);
  r.add("green", 2);
  r.add("blue", 3);
}

void draw() { 
  background(0);  // background black
  fill(c);
  rect(260, 0, 60, height);

  controlP5.draw();
  //  saveFrame("gui.png");
}

void controlEvent(ControlEvent theEvent) {

  if (theEvent.isController()) { 

    print("control event from : "+theEvent.controller().name());
    println(", value : "+theEvent.controller().value());

    if (theEvent.controller().name()=="button") {
      val+=theEvent.controller().value();
      if (val<255) c = color(val, 255, val);
      else val = 0;
    }

    if (theEvent.controller().name()=="slider") {
      float val = theEvent.controller().value();
      c = color (val, 255, 0);
    }

    if (theEvent.controller().name()=="knob") {
      float val = theEvent.controller().value();
      c = color (0, 255, val);
    }
  }
}

void numberbox(float valeur) {
  println("un valeur reçu par numberbox1: "+valeur);
  c = color(255, valeur, 0);
}

public void bang() {
  println("un event reçu par bang");
  c = color(random(255), random(255), random(255));
}

void toggle(boolean etat) {
  if (etat==true) {
    println("toggle state is true");
    c = color(255);
  } 
  else {
    println("toggle state is false");
    c = color(25);
  }
}
void radio(int val) {
  if (val == 1) c = color(255, 0, 0);  
  if (val == 2) c = color( 0, 255, 0);  
  if (val == 3) c = color(0, 0, 255 );
}

